<?php

class PixelExit_ForumStats_Model_GetUserGroups
{
    public static function fetchUsergroup()
    {
        $options = XenForo_Application::get('options');

        if ($options->peForumStatsLegend)
        {
            $chooseUserGroups = $options->peChooseUserGroups;
            $chooseUserGroups = explode(',', $chooseUserGroups);

            $peForumStatsLegendCache = XenForo_Application::getSimpleCacheData('peForumStatsLegend');

            if ($peForumStatsLegendCache === false
                || $peForumStatsLegendCache['lastUpdateDate'] < (XenForo_Application::$time - 86400)
			)
            {
                $peForumStatsLegendCache = self::rebuildForumStatsLegendCache($chooseUserGroups);
            }

            foreach ($chooseUserGroups as $userGroup)
            {
                if (!isset($peForumStatsLegendCache['peUserGroups'][$userGroup]))
                {
                    $peForumStatsLegendCache = self::rebuildForumStatsLegendCache($chooseUserGroups);
                }
            }

            foreach ($chooseUserGroups as $userGroup)
            {
                if (isset($peForumStatsLegendCache['peUserGroups'][$userGroup]))
                {
                    $peForumStatsLegend[] = array("usergroup" => $peForumStatsLegendCache['peUserGroups'][$userGroup]);
                }
            }

            return $peForumStatsLegend;
        }
    }

    public static function rebuildForumStatsLegendCache(array $chooseUserGroups)
    {
        $userGroupsModel = XenForo_Model::create('PixelExit_ForumStats_Model_Legend');

        $peUserGroups = $userGroupsModel->getUserGroupByIds($chooseUserGroups);

        $peForumStatsLegendCache = array(
            'peUserGroups' => $peUserGroups,
            'lastUpdateDate' => XenForo_Application::$time
        );
		
        XenForo_Application::setSimpleCacheData('peForumStatsLegend', $peForumStatsLegendCache);

        return $peForumStatsLegendCache;
    }
}